/* zakob.c */

#include <xsp2lib.h>

#include "../main.h"
#include "../player.h"
#include "../enemy.h"
#include "../eshot.h"
#include "../effect.h"
#include "../psearch.h"


/* ֐vg^Cv錾 */
static short EnemyMoveZakoA (ENEMY *);
static void EnemyFreeZakoA (ENEMY *);


/* [` */
void EnemyAllocZakoA (ENEMY * p)
{
	p->pt = obj_zako02 + 15;
	p->info = 0x0700 | PRIORITY_ZAKO;	/* l߂ē̂͂悭Ȃ */
	p->hit_sx = 12;		/* @Vbgɑ΂铖蔻 */
	p->hit_sy = 12;
	p->hp = 1;		/* ϋv */
	p->damage = 0;
	p->func_enemy_move = EnemyMoveZakoA;
	p->func_enemy_free = EnemyFreeZakoA;

	/* RA֘A */
	p->core_info = PALET_CORE_BLUE | PRIORITY_ZAKO;
	p->core_pt = sp_core + 1;
}


/* ړ[` */
/* ԂlFOȂ */
static short EnemyMoveZakoA (ENEMY * p)
{
	/* G邭񂷃Aj[V */
	p->pt--;
	if (p->pt < obj_zako02)
		p->pt = obj_zako02 + 15;

	/* wW@ɋ߂Â */
	if (p->lx > player->lx)
		p->lx -= 32768;
	else
		p->lx += 32768;

	p->ly += 2 * 65536;

	/* ʃ[hiŒ萮jo */
	p->x = p->lx >> 16;
	p->y = p->ly >> 16;

	if (p->y > 256 + 32)
		return (-1);	/* xW 256+32 ȏȂ */

	/* O_[W󂯂Ȃ */
	if (p->damage) {
		p->hp -= p->damage;
		p->damage = 0;
		/* ϋv͂OȉȂ */
		if (p->hp <= 0) {
			EffectAlloc (EFFECT_EXPLZAKO, 0, p->x, p->y);	/* p^[o */
			return (-1);
		}
	}
	xobj_set_st (p);	/* \ */

	/* RA̕\ */
	p->core_x = p->x - 8;
	p->core_y = p->y - 8;
	xsp_set_st (&(p->core_x));

	return (0);
}


/* [` */
static void EnemyFreeZakoA (ENEMY * p)
{
}
