/* zakoa.c */

#include <xsp2lib.h>

#include "../main.h"
#include "../player.h"
#include "../enemy.h"
#include "../eshot.h"
#include "../effect.h"
#include "../psearch.h"


/* ֐vg^Cv錾 */
static short EnemyMoveZakoB (ENEMY *);
static void EnemyFreeZakoB (ENEMY *);


/* [` */
void EnemyAllocZakoB (ENEMY * p)
{
	p->pt = obj_zako02;
	p->info = 0x0800 | PRIORITY_ZAKO;	/* l߂ē̂͂悭Ȃ */
	p->hit_sx = 12;		/* @Vbgɑ΂铖蔻 */
	p->hit_sy = 12;
	p->hp = 2;		/* ϋv */
	p->damage = 0;
	p->func_enemy_move = EnemyMoveZakoB;
	p->func_enemy_free = EnemyFreeZakoB;

	p->s_work = 0;		/* Vbgp[N */

	/* RA֘A */
	p->core_info = PALET_CORE_BLUE | PRIORITY_ZAKO;
	p->core_pt = sp_core + 1;
}



/* ړ[` */
/* ԂlFOȂ */
static short EnemyMoveZakoB (ENEMY * p)
{
	/* G邭񂷃Aj[V */
	p->pt++;
	if (p->pt > obj_zako02 + 15)
		p->pt = obj_zako02;


	/* wW@ɋ߂Â */
	if (p->lx > player->lx)
		p->lx -= 32768;
	else
		p->lx += 32768;

	p->ly += 2 * 65536;

	/* ʃ[hiŒ萮jo */
	p->x = p->lx >> 16;
	p->y = p->ly >> 16;

	/* ei30t[ɂP񔭎ˁj */
	if (p->s_work++ > 30) {
		char angle;
		p->s_work = 0;
		angle = psearch (p->x, p->y);	/* G猩@̕ unsigned char ŕԂ */
		EshotAlloc (0, p->x, p->y, 10, angle);	/* e */
	}
	if (p->y > 256 + 32)
		return (-1);	/* xW 256+32 ȏȂ */

	/* O_[W󂯂Ȃ */
	if (p->damage) {
		p->hp -= p->damage;
		p->damage = 0;
		/* ϋv͂OȉȂ */
		if (p->hp <= 0) {
			EffectAlloc (EFFECT_EXPLZAKO, 0, p->x, p->y);	/* p^[o */
			return (-1);
		}
	}
	xobj_set_st (p);	/* \ */

	/* RA̕\ */
	p->core_x = p->x - 8;
	p->core_y = p->y - 8;
	xsp_set_st (&(p->core_x));

	return (0);
}


/* [` */
static void EnemyFreeZakoB (ENEMY * p)
{
}

